/**
 *  Thread that sychronizes the Video and Audio Players 
 */

package media.network;
import javax.media.*;

public class MediaSyncT extends Thread {

   private boolean terminateThread = false;  //boolean if terminated
   private VideoReceiver video_receiver;  //video receiver
   private AudioReceiver audio_receiver;  //audio receiver
    
    /**
     * Creates a new media synchronizer with the videoplayer and audioplayer specified
     */

    public MediaSyncT(VideoReceiver video_receiver, AudioReceiver audio_receiver){
      this.audio_receiver = audio_receiver;
      this.video_receiver  = video_receiver;
      this.run();
    }

    public void startboth(){
	video_receiver.video_player.start();
        audio_receiver.audio_player.start();
	
	
    }


   /**
    * Starts the MediaSychronizer Thread
    */
   public void run() {
     
       while (!terminateThread){
	   if ((audio_receiver.isRealized())&& (video_receiver.isRealized())){
	       this.startboth();  //starts both players if they are both realized	
	       System.out.println("Both realized");
	       while ((audio_receiver.audio_player.getState() != Processor.Realized) || (video_receiver.video_player.getState() != Processor.Realized)) ;
	       try {
		   System.out.println("Joining");
		   video_receiver.video_player.addController(audio_receiver.audio_player);
	       } catch (Exception bubba) { System.out.println(bubba); }
           }
       }   
   }
 
   /**
    * Terminates the Thread
    */
   public void stopIt(){
       //video_receiver.videoplayer.stop();
       audio_receiver.audio_player.stop();
     terminateThread = true;

   }
}
